<?php
/*=============================================================*\
|| ########################################################### ||
|| #        BS-Fusion - Content Management System            # ||
|| #                    Version 1.x                          # ||   
|| # ------------------------------------------------------- # ||
|| # Copyright 2009 BS-Fusion All rights reserved.          # ||
|| # Author: Manuel Kurz                                     # ||
|| # ------------------------------------------------------- # ||
|| # This program is released as open source software under  # ||
|| # the Affero GPL license (version 3).                     # ||
|| # License: http://www.gnu.org/licenses/agpl-3.0.html.     # || 
|| # Removal of this copyright header is strictly prohibited # ||
|| # without written permission from the original author(s). # ||
|| # -------- BS-FUSION IS AN OPEN SOURCE SOFTWARE --------- # ||
|| #    http://www.bs-fusion.de | http://www.bsfusion.de     # ||
|| ########################################################### || 
\*=============================================================*/ 
/**
* @package SPLIB
*/
/**
* MySQL-Klasse zum Verbindungsaufbau
* @access public
* @package SPLIB
*/
class MySQL {
    /**
    * Hostname des MySQL-Servers
    * @access private
    * @var string
    */
    var $host;
    
    /**
    * MySQL-Benutzername
    * @access private
    * @var string
    */
    var $dbUser;

    /**
    * MySQL-Passwort
    * @access private
    * @var string
    */
    var $dbPass;
    
    /**
    * Name der ausgewhlten Datenbank
    * @access private
    * @var string
    */
    var $dbName;
    
    /**
    * MySQL-Verbindungskennung
    * @access private
    * @var string
    */
    var $dbConn;
    
    /**
    * Fehler beim Verbindungsaufbau werden in dieser
    * Variablen gespeichert
    * @access private
    * @var string
    */
    var $connectError;
    
    /**
    * MySQL-Konstruktor
    * @param string host (Hostname des MySQL-Servers)
    * @param string dbUser (MySQL-Benutzername)
    * @param string dbPass (MySQL-Passwort)
    * @param string dbName (Name der Datenbank)
    * @access public
    */
    
    var $db_queries;
    var $db_queries_time;
	
	function MySQL($db_host,$db_user,$db_pass,$db_name) {
		
        $this->host=$db_host;
        $this->dbUser=$db_user;
        $this->dbPass=$db_pass;
        $this->dbName=$db_name;
        $this->db_queries=0;
        $this->db_queries_time="";
        $this->connectToDb();
    }
    /**
    * Verbindet zu MySQL und whlt eine Datenbank aus
    * @return void
    * @access private
    */
    function connectToDb () {
        // Baut die Verbindung zum MySQL-Server auf
        if (!$this->dbConn = @mysql_connect($this->host,
                                            $this->dbUser,
                                            $this->dbPass)) {
            trigger_error('Could not connect to server');
            $this->connectError=true;
        // Whlt eine Datenbank aus
        } else if ( !@mysql_select_db($this->dbName,$this->dbConn) ) {
            trigger_error('Could not select database');
            $this->connectError=true;
        }
    }
    
    /** Abfrage ob eine Tabelle existiert **/
    function mysql_table_exists($table) {
    $table=!isset($table) || empty($table) ? null : htmlentities($table);
	if (!isset($table)) {return false;}
	else {
	$res = $this->query("SHOW TABLES WHERE Tables_in_".$this->dbName."='".$table."'");
	if ($res->size()>0) {
		return true;
	} else {
		return false;
	}
	
	}
}
    
 	/** Abfrage ob ein Tabellenfeld existiert **/
    function mysql_field_exists($table=null,$field=null) {
    	$field=!isset($field) || empty($field) || !$this->mysql_table_exists($table) ? null : htmlentities($field);
		$table=!isset($table) || empty($table) ? null : htmlentities($table);	
    if (!isset($table) || !isset($field)) {return false;}
	else {	
	$fields = $this->query("SHOW COLUMNS FROM ".$this->dbName.$table." WHERE Field='".mysql_escape_string($field)."'");
	if ($fields->size()>0) {
		return true;
	} else {
		return false;
	}
	} 
}

	function mysql_indizes($table) {
		$res=$this->query("SHOW INDEX FROM ".$this->dbName.".".$table);
		$rows=$res->size();$indizes;
			if ($rows>0) {
				while($row=$res->fetch()) {
					$indizes[]=$row['Key_name'];
				}
			}
			 return $indizes;
	}
	
	function mysql_drop_indizes($table,$key_name) {
		if (!$res=$this->query("ALTER TABLE ".$this->dbName.".".$table." DROP INDEX ".mysql_escape_string($key_name))) return false;
		else return true;
		
	}
	
	function mysql_add_indizes($table,$key_name,$column_name,$type='INDEX') {
		$add_array = array("INDEX","UNIQUE","PRIMARY","FULLTEXT");
		
		if (!in_array($type,$add_array)) {return false;} else {
		$my_indizes=$this->mysql_indizes($table);
		if (in_array($key_name,$my_indizes)) $this->mysql_drop_indizes($table,$key_name);	
		if (!$res=$this->query("ALTER TABLE ".$this->dbName.".".$table." ADD ".$type." ".mysql_escape_string($key_name)." (".$column_name.")")){ return false;
		} else {$res=$this->query("OPTIMIZE TABLE ".$table);  return true;}
		}
		
	}
    
    
    /**
    * Fragt MySQL-Fehler ab
    * @return boolean
    * @access public
    */
    function isError () {
        if ( $this->connectError )
            return true;
        $error=mysql_error ($this->dbConn);
        if ( empty ($error) )
            return false;
        else
            return true;
    }
    
    /**
    * Gibt eine Instanz von MySQLResult zurck, um Zeilen
    * aus dem Abfrageergebnis zu holen
    * @param $sql string die auszufhrende Datenbankabfrage
    * @return MySQLResult
    * @access public
    */
    function query($sql) {
    	$mtimecounter=$this->get_mtime_counter();
        if (!$queryResource=mysql_query($sql,$this->dbConn))
            trigger_error ('Query failed: '.mysql_error($this->dbConn).' SQL: '.$sql);
        $this->db_queries++;    
       	$this->db_queries_time[$this->db_queries]=$this->get_mtime_counter()-$mtimecounter;
       	
       	return new MySQLResult($this,$queryResource);
    }
    
    
    function show_queries() {
    	return (string)(int)$this->db_queries;
    }
    
    function show_queries_time() {
    	$times=0;
		foreach ($this->db_queries_time as $time)
    	$times+=$time;
    	return number_format($times,5,".",",");
    }
    
    function get_mtime_counter() {
	$mtime = explode(" ",microtime());
	return $mtime[1] + $mtime[0];
    }
}

/**
* MySQLResult-Klasse fr Abfrageergebnisse
* @access public
* @package SPLIB
*/
class MySQLResult {
    /**
    * Instanz von MySQL, die eine Datenbankverbindung zur
    * Verfgung stellt
    * @access private
    * @var MySQL
    */
    var $mysql;
    
    /**
    * Kennung eines Abfrageergebnisses
    * @access private
    * @var resource
    */
    var $query;
    
    /**
    * MySQLResult-Konstruktor
    * @param object mysql (Instanz der MySQL-Klasse)
    * @param resource query (MySQL-Ergebniskennung)
    * @access public
    */
    function MySQLResult($mysql,$query) {
        $this->mysql= $mysql;
        $this->query=$query;
    }
    
    /**
    * Liest eine Zeile des Abfrageergebnisses
    * @return array
    * @access public
    */
    function fetch() {
        if ( $row=mysql_fetch_array($this->query,MYSQL_ASSOC) ) {
            return $row;
        } else if ( $this->size() > 0 ) {
            mysql_data_seek($this->query,0);
            return false;
        } else {
            return false;
        }
    }
    
    /**
    * Gibt die Anzahl der Zeilen in einem Ergebnis zurck
    * @return int
    * @access public
    */
    function size () {
        return mysql_num_rows($this->query);
    }
    
    /**
    * Gibt die Anzahl der Zeilen in einem Ergebnis zurck
    * @return int
    * @access public
    */
    
    function rows () {
        return mysql_result($this->query,0);
    }
    
    /**
    * Gibt die Anzahl die Zeile eines Ergebnisses zurck
    * @return var
    * @access public
    */
    
    function result($row=0) {
        return mysql_result($this->query,$row);
    }
    
	/**
    * Liest eine Zeile des Abfrageergebnisses
    * @return objekt
    * @access public
    */
	function fetch_object () {
        if ($row=mysql_fetch_object($this->query)) {
            return $row;
        } else if ($this->size() > 0) {
            mysql_data_seek($this->query,0);
            return false;
        } else {
            return false;
        }
    }
    /**
    * Liest eine Zeile des Abfrageergebnisses
    * @return array
    * @access public
    */
	function fetch_row () {
        if ($row=mysql_fetch_row($this->query)) {
            return $row;
        } else if ($this->size() > 0) {
            mysql_data_seek($this->query,0);
            return false;
        } else {
            return false;
        }
    }
	    
    /**
    * Gibt den ID des zuletzt eingefgten Records zurck
    * @return int
    * @access public
    */
    function insertID () {
        return mysql_insert_id($this->mysql->dbConn);
    }
    
    /**
    * Fragt MySQL-Fehler ab
    * @return boolean
    * @access public
    */
    function isError () {
        return $this->mysql->isError();
    }
}
// Silvermoon
function first_query($fields,$table,$where="") {
	global $db;

    	$res = $db->query("SELECT ".$fields." FROM ".$table.($where!=""? " WHERE ".$where:"")." LIMIT 0,1");
    	
    	if ($res->size()==1) return $res->fetch();
		else return false; 
    }
?>