<?php
/*=============================================================*\
|| ########################################################### ||
|| #        BS-Fusion - Content Management System            # ||
|| #                    Version 1.x                          # ||   
|| # ------------------------------------------------------- # ||
|| # Copyright 2009 BS-Fusion All rights reserved.          # ||
|| # Author: Manuel Kurz                                     # ||
|| # ------------------------------------------------------- # ||
|| # This program is released as open source software under  # ||
|| # the Affero GPL license (version 3).                     # ||
|| # License: http://www.gnu.org/licenses/agpl-3.0.html.     # || 
|| # Removal of this copyright header is strictly prohibited # ||
|| # without written permission from the original author(s). # ||
|| # -------- BS-FUSION IS AN OPEN SOURCE SOFTWARE --------- # ||
|| #    http://www.bs-fusion.de | http://www.bsfusion.de     # ||
|| ########################################################### || 
\*=============================================================*/ 
/**
* @package SPLIB
* @version $Id: Session.php,v 1.6 2003/08/17 22:13:17 harry Exp $
* @access public
*/
class Session {
    /**
    * Session-Konstruktor<br />
    * Startet die Session mit session_start()
    * <b>Beachten Sie:</b> Wenn die Session bereits
    * gestartet wurde, bleibt session_start() wirkungslos
    * @access public
    */
    function Session() {
    	session_set_cookie_params(0,COOKIE_PATH,"",SSL_COOKIE);
		session_name("sid");
        if (!session_id()) session_start();
    }

    /**
    * Setzt eine Sessionvariable
    * @param string Name der Variablen
    * @param mixed Wert der Variablen
    * @return void
    * @access public
    */
    function set ($name,$value) {
        $_SESSION[$name]=$value;
    }

    /**
    * Holt eine Sessionvariable
    * @param string Name der Variablen
    * @return mixed Wert der Sessionvariablen
    * @access public
    */
    function get ($name) {
        if ( isset ( $_SESSION[$name] ) )
            return $_SESSION[$name];
        else
            return false;
    }

    /**
    * Lscht eine Sessionvariable
    * @param string Name der Variablen
    * @return void
    * @access public
    */
    function del ($name) {
        if ( isset ( $_SESSION[$name] ) ) {
            unset ( $_SESSION[$name] );
            return true;
        } else {
            return false;
        }
    }

    /**
    * Zerstrt die gesamte Session
    * @return void
    * @access public
    */
    function destroy () {
        $_SESSION = array();
        session_destroy();
    }
}
?>