<?php
/*=============================================================*\
|| ########################################################### ||
|| #        BS-Fusion - Content Management System            # ||
|| #                    Version 1.x                          # ||   
|| # ------------------------------------------------------- # ||
|| # Copyright 2009-2010 BS-Fusion All rights reserved.     # ||
|| # Author: Manuel Kurz                                     # ||
|| # ------------------------------------------------------- # ||
|| # This program is released as open source software under  # ||
|| # the Affero GPL license (version 3).                     # ||
|| # License: http://www.gnu.org/licenses/agpl-3.0.html.     # || 
|| # Removal of this copyright header is strictly prohibited # ||
|| # without written permission from the original author(s). # ||
|| # -------- BS-FUSION IS AN OPEN SOURCE SOFTWARE --------- # ||
|| #    http://www.bs-fusion.de | http://www.bsfusion.de     # ||
|| ########################################################### || 
\*=============================================================*/
if (!defined("IN_FUSION") || !IN_FUSION) die('Access denied');

class template {
	var $templateDir;
	var $file_read;
	var $ext;
	var $config;
	var $lang;
	var $udata;
	var $theme;
	var $theme_url;
	var $jscript_url;
	var $title = null;
	var $description = null;
	var $keywords = null;
	var $scripts = null;
	var $css = null;
	var $head_text = null;
	var $defaultTemplateDir = null;
	var $mod_rewrite = false;
	var $meta=null;
	
	function template($templateDir,$ext="html")	{
		global $settings,$locale,$userdata;
		$this->config=isset($settings) ? $settings : false;
		$this->lang=isset($locale) ? $locale : false;
		$this->udata=isset($userdata) ? $userdata : false;
		$this->templateDir=$templateDir;
		$this->ext=$ext;
		$this->theme_url=THEME;
		$this->theme=basename(THEME);
		$this->jscript_url=BASEURL."jscripts/";
		$this->defaultTemplateDir=str_replace("/".$this->config['template']."/","/default/",$this->templateDir);
		
	}


/**
 * Einfuegen von eigenen Seitentitel, eigener Seitenbeschreibung, eigener Keywords 
 */	
 		 
		function add_to_header($title=null,$description=null,$keywords=null) 
		{
			$this->title=$title;
			$this->description=$description;
			$this->keywords=$keywords;		
		}
			 
/**
 * Einfuegen von weitere JavaScript Daten
 */		
		function more_javascript($scripts=null,$type='file') {
		$this->scripts='';	
		switch($type) {
			case 'text':
				if (isset($scripts)) {
			if (is_array($scripts)) {
					foreach($scripts as $scripttext) {
						$this->scripts.=$scripttext."\n";
					}
			} else {
				$this->scripts.=$scripts;
			}
			}
			break;
			default:
			if (isset($scripts)) {
			if (is_array($scripts)) {
					foreach($scripts as $scriptfile) {
						$this->scripts.='<script type="text/javascript" src="'.$scriptfile.'"></script>'."\n";
					}
			} else {
				$this->scripts.='<script type="text/javascript" src="'.$scripts.'"></script>';
			}
			}
			break;
			}
			}
		/**
 * Einfuegen von weiteren CSS Daten
 */		
		function more_css($css=null,$type='file') {
		$this->css='';	
		switch($type) {
			case 'text':
				if (isset($css)) {
			if (is_array($css)) {
					foreach($css as $csstext) {
						$this->css.=$csstext."\n";
					}
			} else {
				$this->css.=$css;
			}
			}
			break;
			default:
			if (isset($css)) {
			if (is_array($css)) {
					foreach($css as $cssfile) {
						$this->css.='<link rel="stylesheet" type="text/css" href="'.$cssfile.'">'."\n";
					}
			} else {
				$this->css.='<link rel="stylesheet" type="text/css" href="'.$css.'">';
			}
			}
			break;
			}
			}	
	
/**
 * Einfuegen von weitere MetaAngaben
 */		
		function add_meta($name,$content,$type="name") {
			$this->meta.="<meta ".$type."=\"".$name."\" content=\"".$content."\" />\n";
		}
		
/**
 * Einfuegen von einem eigenen Seitentitel
 */		
		function add_to_title($title=null) {
			$this->title=$title;
		}	 
/**
 * Einfuegen von Weitere Angaben im <head> </head> 
 */	
		function add_head($text=null) {
			if (isset($text) && $text!="")
			$this->head_text.=$text."\n";
		}

		
function loadHeader($robots=true,$ref=array()) {
global $folder_level,$rootfolder,$PHP_SELF;	
if (!defined("DOCTYPE")) define("DOCTYPE",'html');

switch(DOCTYPE) {
	case 'xhtml':
	echo '<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="en" lang="en">';
	break;
	default:
echo '<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN" "http://www.w3.org/TR/html4/loose.dtd">
<html>';
break;
}
$this->config['sitetitle']=!isset($this->config['sitetitle']) ? $this->config['sitename'] : $this->config['sitetitle'];
$this->config['sitename']=substr($this->config['sitename'],0,50);
echo '<head><title>'.(!isset($this->title) && $this->title=='' ? $this->config['sitetitle'] : $this->title. " - ".$this->config['sitename']).'</title>';
if (count($ref)==2) echo '<meta http-equiv="refresh" content="'.$ref[0].'; url='.$ref[1].'">';
echo '<meta http-equiv="Content-Type" content="text/html; charset='.$this->lang['charset'].'" /><meta name="description" content="'.(isset($this->description) && $this->description!="" ? $this->description : $this->config['description']).'" />'.(!(bool)$this->mod_rewrite  ? '' : "".'<base href="'.BASEURL.'" />').'<meta name="keywords" content="'.(!isset($this->keywords) || $this->keywords=='' ? $this->config['keywords'] : $this->keywords.",".$this->config['keywords']).'" /><meta http-equiv="content-language" content="de" /><link rel="shortcut icon" href="'.BASEURL.'favicon.ico" type="image/x-icon"><meta name="robots" content="'.((bool)$robots ? 'INDEX,FOLLOW' : 'NOINDEX,NOFOLLOW,NOARCHIVE').'" />'.(!isset($this->meta) ? '' : $this->meta).(!isset($this->head_text) ? '':$this->head_text);

// CSS Section
echo '<link rel="stylesheet" href="'.$this->theme_url.'styles.css" type="text/css" media="screen" />';
// highslide css special for IE
echo '<style type="text/css">.highslide{cursor:url("'.$this->jscript_url.'highslide/graphics/zoomin.cur"),pointer;outline:none;}.highslide-active-anchor img{visibility:hidden;}.highslide img{border:2px solid white;}.highslide:hover img{border:2px solid gray;}.highslide-wrapper{background:white;}.highslide-image{border:2px solid white;}.highslide-caption{display:none;border:2px solid white;border-top:none;font-family:Verdana,Helvetica;font-size:10pt;padding:5px;background-color:white;}.highslide-loading{display:block;color:black;font-size:8pt;font-family:sans-serif;font-weight:bold;text-decoration:none;padding:2px;border:1px solid black;background-color:white;padding-left:22px;background-image:url("'.$this->jscript_url.'highslide/graphics/loader.white.gif");background-repeat:no-repeat;background-position:3px 1px;}a.highslide-credits,a.highslide-credits i{padding:2px;color:blue;text-decoration:none;font-size:8px;}a.highslide-credits:hover,a.highslide-credits:hover i{color:white;}a.highslide-full-expand{background:url("'.$this->jscript_url.'highslide/graphics/fullexpand.gif") no-repeat;display:block;margin:0 10px 10px 0;width:34px;height:34px;}</style>';	
if (isset($this->css))
echo $this->css;
// JavaScript section
echo '<script type="text/javascript" src="'.$this->jscript_url.'highslide/highslide.js"></script>';
echo '<script type="text/javascript">hs.graphicsDir = "'.$this->jscript_url.'highslide/graphics/";</script>';		
echo '<script type="text/javascript" src="'.$this->jscript_url.'jscript.js"></script>';
echo '<script type="text/javascript" src="'.$this->jscript_url.'jquery.js"></script>';
if (isset($this->scripts))
echo $this->scripts;
}
	
// einbinden der Templatedatei
function includeTemplateFile($templatefile,$subfolder=null) {
	global $tpl;
	$folder = (isset($subfolder) ? $subfolder.'/' : '');
		if (file_exists(THEME."templates/".$folder.$templatefile))			{
				@include_once(THEME."templates/".$folder.$templatefile);
			
			return $tpl;
		 }	
		else if (file_exists($this->templateDir.$folder.$templatefile)) {
			@include_once($this->templateDir.$folder.$templatefile);
			return $tpl;
		} elseif (file_exists($this->defaultTemplateDir.$folder.$templatefile)) {
			@include_once($this->defaultTemplateDir.$folder.$templatefile);
			return $tpl;
		} else {
			@ob_end_clean();
			die('Template file <strong>"'.$templatefile.'"</strong>not found!');
			return false;
		}	
}

function clean_title($title="") {
	$nreplace = array("&","", "", "", '', "", "", "","","","");
	$nsearch = array("&amp;","&quot;", "&#39;", "&#92;", "&quot;", "&#39;", "&lt;", "&gt;","&copy;","&reg;","&trade;");
	//$title=str_replace($nsearch,$nreplace,$title);	
	$umlaute = array("","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","");
	$umlaute_search=array_map('htmlentities',$umlaute);
	$umlaute_url_encode=array_map("urlencode",$umlaute);
	$umlaute_rawurl_encode=array_map("rawurlencode",$umlaute);
	$umlaute_replace=array("ae","a","a","a","Ae","A","A","A","e","e","e","e","E","E","E","E","i","i","i","i","I","I","I","I","oe","o","o","o","Oe","O","O","O","ue","u","u","u","Ue","U","U","U","ss","euro");
	$search1=array_merge($umlaute,$umlaute_search,$umlaute_url_encode,$umlaute_rawurl_encode);
	$replace1=array_merge($umlaute_replace,$umlaute_replace,$umlaute_replace,$umlaute_replace);
	//$title=str_replace($search1,$replace1,$title);
	
    $search = array(" ","&amp;","&","RE: ","RE:");
	$search_enitites=array_map('htmlentities',$search);
	$search_url_encode=array_map("urlencode",$search);
	$search_rawurl_encode=array_map("rawurlencode",$search);
	$replace = array("-","and","and","-","-");
	
	$seosearch=array_merge($nsearch,$search1,$search,$search_enitites,$search_rawurl_encode,$search_url_encode);
	$seoreplace=array_merge($nreplace,$replace1,$replace,$replace,$replace,$replace);
	
	$title=str_replace($seosearch,$seoreplace,$title);
  	 $title = preg_replace("/[^\d\w\s]+/", "-", $title);
      $title = trim($title, "-");
      $title = strtolower($title);
return $title;
}
function url($folder=null,$datei=null,$name=null,$id=null,$name2=null,$id2=null,$title=null,$realfolder=null,$trenner=',',$nr=null) {
		if ((bool)$this->mod_rewrite)  {
		$titel=explode("/",$title);	
		$title=$this->clean_title($titel[0]);
		
		$url = BASEURL.$folder.
		(!isset($id) || empty($id) ? '' : ','.$id.(!isset($id2) || $id2=='' || !(bool)$id2 ? ',' : ",".$id2.',')).(!isset($title) || $title=='' || !(bool)$title ? '.html' : $title.".html").(!isset($nr) || isset($nr) && $nr!='' && (!isset($id2) || $id2=='') ? '' : '#'.$nr.$id2)."";
		} else {
		
		if (!isset($_COOKIE[session_name()])) $slnk=SID; else $slnk="";	
		$url = BASEURL.(!isset($realfolder) || empty($realfolder) ? '' : $realfolder.'/').$datei.(!isset($name) || isset($name) && !isset($id) || $name=="" || $id=="" ? ($slnk!='' ? '?'.$slnk :'') : '?'.($slnk!='' ? $slnk."&amp;" :'').$name.$id).(!isset($name2) || isset($name2) && !isset($id2) ? '' : '&amp;'.$name2.$id2).(!isset($nr) || isset($nr) && !isset($id2) ? '' : '#'.$nr.$id2);	
		}
		return $url;
}
	
function link_change($folder=null,$file=null,$query=null,$link_name=null,$url=null) {
		$id="";$cat_id="";
		switch($file) {
			case 'viewpage.php';
			if(isset($query) && !empty($query)) {
				$id = str_replace("=","",strstr($query,"="));
				$name = str_replace($id,"",$query); 
			}
			return $this->url(SEO_PAGE,$file,$name,$id,null,null,$link_name,(!preg_match('/.php/i',$folder) ? $folder : null));			
			break;
			case 'articles.php';
			if(isset($query) && !empty($query)) {
				$cat_id = str_replace("cat_id=","",strstr($query,"cat_id="));
				$id = str_replace("id=","",strstr($query,"id="));
				
				$name = str_replace(array($id,$cat_id),"",$query);
			} else {
				$link_name="";
			}
			if ($cat_id!="") {
			return $this->url(SEO_ARTICLE_CAT,$file,'cat_id=',$cat_id,null,null,$link_name,(!preg_match('/.php/i',$folder) ? $folder : null));
			} else {
			return $this->url(SEO_ARTICLE,$file,'id=',$id,null,null,$link_name,(!eregi('.php',$folder) ? $folder : null));	
			}
			break;
			case 'weblinks.php';
			if(isset($query) && !empty($query)) {
				$id = str_replace("=","",strstr($query,"="));
				$name = str_replace($id,"",$query);
			} else {
				$link_name="";
			}
			return $this->url(SEO_LINKS,$file,$name,$id,null,null,$link_name,(!preg_match('/.php/i',$folder) ? $folder : null));
			break;
			case 'faq.php';
			if(isset($query) && !empty($query)) {
				$id = str_replace("=","",strstr($query,"="));
				$name = str_replace($id,"",$query);
			} else {
				$link_name="";
			}
			return $this->url(SEO_FAQ,$file,$name,$id,null,null,$link_name,(!preg_match('/.php/i',$folder) ? $folder : null));
			break;
			case 'downloads.php';
			if(isset($query) && !empty($query)) {
				$id = str_replace("=","",strstr($query,"="));
				$name = str_replace($id,"",$query);
			} else {
				$link_name="";
			}
			return $this->url(SEO_DOWNLOAD,$file,$name,$id,null,null,$link_name,(!preg_match('/.php/i',$folder)  ? $folder : null));
			break;
			case 'index.php';
				if (isset($folder) && $folder=='forum') {
					if(isset($query) && !empty($query)) {
						$id = str_replace("=","",strstr($query,"="));
						$name = str_replace($id,"",$query);
					} else {
						$link_name="";
					}
				return $this->url(SEO_FORUM,$file,$name,$id,null,null,$link_name,(!preg_match('/.php/i',$folder)  ? $folder : null));
				}
			else {
			return BASEURL.$url;	
			}	
		
			break;
			default:
			return BASEURL.$url;
			break;
		}
} 

function w3c_valid($text,$valid='html') {	
$slash_tags=array('br','hr','img','link','meta','input','base');
$actions = array('href','src','action','var site');
$text=str_replace(array(" />","/>"," >","\t"),array(">",">",">",""),$text);
switch(DOCTYPE) {
	case 'xhtml':
	foreach($slash_tags as $tag) {	
$text = preg_replace("/\<{$tag}(.*?)\>/i", '<'.$tag.'\1 />', $text);		
}
	break;
	default:
$text = preg_replace("/\<\/col\>/i", '', $text);	
	break;
	}
foreach($actions as $action) {	
$text = str_replace("$action='".BASEDIR, $action.'=\''.BASEURL, $text);
$text = str_replace("$action=\"".BASEDIR, $action.'="'.BASEURL, $text);
}	
return $text;
}

function writeContent($content,$meta_content='') {
	global $folder_level;
	header("X-Powered-By: BS-Fusion CMS ".$this->config['version'],true);
	header("Server: \"\"",true);
	header("P3P: CP=\"NOI ADM DEV PSAi COM NAV OUR OTRo STP IND DEM\"",true);
	header("Cache-Control: no-store, no-cache",true);
	header("Cache-Control: post-check=0, pre-check=0, public, max-age=0, privat, must-revalidate", true);
	header("Last-Modified: ".gmstrftime("%a, %b %d %Y %H:%M:%S GMT",time()),true);
	ob_start();
	$content = $this->w3c_valid($content);
	echo $content;
	if(ob_get_length () !== FALSE){ob_end_flush();}
}	
}
?>