<?
/**
 * pd Similar Threads (PHP-Fusion)
 * show similar forum threads
 * @author: pirdani <http://www.pirdani.de> <kontakt@pirdani.de>
 * @version 0.1.0
 * 
 * Release under the terms & conditions of v3 or higher
 * of the GNU General Public License. For details refer 
 * to the included gpl.txt file or visit http://gnu.org
  */
/*---------------------------------------------------------+
| BS-Fusion - Content Management System
| Version 1.00.0
+----------------------------------------------------------+
| Copyright  2009 Manuel Kurz
| http://www.bs-fusion.org/
+----------------------------------------------------------+
| This program is released as free software under the
| Affero GPL license (version 3). You can redistribute 
| it and/or modify it under the terms of this license which 
| you can read by viewing the included agpl-3.0.txt or 
| online at http://www.gnu.org/licenses/agpl-3.0.html. 
| Removal of this copyright header is strictly prohibited 
| without written permission from the original author(s).
+----------------------------------------------------------+
| Code based on PHP-Fusion
| http://www.php-fusion.co.uk/
+---------------------------------------------------------*/
@require_once(LOCALE.LOCALESET."forum.php");
//include("st_config.php");

# CONFIG
# how many threads in the threadview list
$threadview_list_cnt = 5;

# small words remove count
$min_words_cnt = 4;

# minimal word length 
$min_words_len = 5;

# words replace array
$replace_words_array = array(
	array("old" => ".", "new" =>" "),
	array("old" => "-", "new" =>" "),
	array("old" => "_", "new" =>" "),
	array("old" => "=", "new" =>" "),
	array("old" => "(", "new" =>" "),
	array("old" => ")", "new" =>" "),
	array("old" => "[", "new" =>" "),
	array("old" => "]", "new" =>" "),
	array("old" => "{", "new" =>" "),
	array("old" => "}", "new" =>" "),
	array("old" => "?", "new" =>" "),
	array("old" => "&", "new" =>" "),
	array("old" => "!", "new" =>" "),
	array("old" => ":", "new" =>" "),
	array("old" => "/", "new" =>" "),
	array("old" => "\\", "new" =>" "),
	array("old" => "alben ", "new" =>" galerie "),
	array("old" => "album ", "new" =>" galerie "),
	array("old" => " erweiterung", "new" =>" "),
	array("old" => " fehler ", "new" =>" "),
	array("old" => " frage", "new" =>" "),
	array("old" => "funktion", "new" =>" "),
	array("old" => " fr ", "new" =>" "),
	array("old" => "gallerie", "new" =>" galerie"),
	array("old" => "gallery", "new" =>" galerie"),
	array("old" => "hilfe", "new" =>" "),
	array("old" => " infusionen", "new" =>" infusion"),
	array("old" => " in", "new" =>" "),
	array("old" => " im", "new" =>" "),
	array("old" => " knnte", "new" =>" "),
	array("old" => " mein", "new" =>" "),
	array("old" => " menu", "new" =>" men"),
	array("old" => " menue", "new" =>" men"),
	array("old" => " mysql", "new" =>" "),
	array("old" => " panel", "new" =>" "),
	array("old" => " php ", "new" =>" "),
	array("old" => " phpfusion ", "new" =>" fusion "),
	array("old" => " problem", "new" =>" "),
	array("old" => " programmiere", "new" =>" entwickeln"),
	array("old" => " sql ", "new" =>" "),
	array("old" => " statt", "new" =>" "),
	array("old" => " suche", "new" =>" "),
	array("old" => " thema", "new" =>" theme"),
	array("old" => " template", "new" =>" theme"),
	array("old" => " upgrade", "new" =>" update"),
	array("old" => " und", "new" =>" "),
	array("old" => " oder", "new" =>" "),
	array("old" => " nicht", "new" =>" ")
);
	
# alternative words array
$alternative_words_array = array(
	array("word" => "entwickeln", "alternative" =>"entwickeln|programmiere|coden"),
	array("word" => "foto", "alternative" =>"foto|photo|image|bild"),
	array("word" => "galerie", "alternative" =>"galerie|gallerie|gallery|alben|album"),
	array("word" => "men", "alternative" =>"men|menue|menu"),
	array("word" => "theme", "alternative" =>"theme|thema|template"),
	array("word" => "update", "alternative" =>"update|upgrade|aktualisieren")
);

###############################################################################
$min_words_len = 4;
$min_words_cnt = 1;

function pd_getSimilarThreads($tid, $title=FALSE, $cnt=0, $start=0, $order=TRUE, $pagenav=TRUE, $showlink=FALSE) {
  global $min_words_cnt, $min_words_len, $replace_words_array, $alternative_words_array, $locale,$tpl;
  if(!(isset($tid) && isNum($tid))) redirect(BASEDIR."index.php");
  if($title==FALSE) {
    # sql query
    $query = dbquery("SELECT thread_subject FROM ".DB_PREFIX."threads AS t
                      INNER JOIN ".DB_PREFIX."forums AS f USING(forum_id)
                      LEFT OUTER JOIN ".DB_PREFIX."forum_groups fg ON fg.forum_id=f.forum_id AND fg.auth_read='1'"
    ." WHERE (".forum_groupaccess('f.forum_access')."  OR ".forum_groupaccess('fg.group_id').") AND t.thread_id=".$tid." GROUP BY f.forum_id");
    if(!dbrows($query)) redirect(BASEDIR."index.php");
    $tdata = dbarray($query);
    $title = $tdata['thread_subject'];
  }  
  # create arrays
    # replace words
    $old_words = array();
    $new_words = array();
    foreach($replace_words_array as $value) {
  	  array_push($old_words, $value['old']);
  	  array_push($new_words, $value['new']);
    }
    # alternative words
    $alternative_old = array();
    $alternative_new = array();
    foreach($alternative_words_array as $value) {
    array_push($alternative_old, $value['word']);
  	array_push($alternative_new, $value['alternative']);
    }
  # all in lower caps
  $thread_title = " ".(strtolower($title))." ";
  # replace words from old_words with words from new_words
  $thread_title = str_replace($old_words, $new_words, $thread_title);
  # create words array
  $all_words = explode(" ", $thread_title);
  # remove duplicate words
  $all_words = array_unique($all_words);
  # at $min_words_cnt words in the array,
  # remove words with under $min_words_len caps 
  $small_words = array();
  if(count($all_words)>$min_words_cnt) foreach($all_words as $value) if(strlen($value)<$min_words_len) array_push($small_words, "|".$value."|");
  $thread_title = "| |";
  foreach ($all_words as $value) $thread_title .= $value."| |";
  $thread_title = str_replace($small_words, "", $thread_title);
  $thread_title = str_replace("|", " ", $thread_title);
  # create array
  $similar_words = explode(" ", trim($thread_title));
  # remove duplicate words
  $similar_words = array_unique($similar_words);
  # sort array
  sort($similar_words);
  # create where-query
  $where_query = "";
  $simwords_num = count($similar_words);
   
  if ($simwords_num>1) { 
  	for($i=1; $i<$simwords_num; $i++) {
  	if($similar_words[$i]!="") {
		  $arr_key=array_search($similar_words[$i], $alternative_old);
		  if(isNum($arr_key)) {
  			$where_query .= "(t.thread_subject LIKE '%".str_replace("|", "%' OR  t.thread_subject LIKE '%", $alternative_new[$arr_key])."%')".($i<$simwords_num-1 ? ' OR ':'');
		  } else {
  			$where_query .= "t.thread_subject LIKE '%".$similar_words[$i]."%'".($i<$simwords_num-1 ? ' OR ':'');
		  }
	  }			
  	}
  } else {
  	for($i=0; $i<$simwords_num; $i++) {
  	if($similar_words[$i]!="") {
		  $arr_key=array_search($similar_words[$i], $alternative_old);
		  if(isNum($arr_key)) {
  			$where_query .= "(t.thread_subject LIKE '%".str_replace("|", "%' OR  t.thread_subject LIKE '%", $alternative_new[$arr_key])."%')".($i<$simwords_num-1 ? ' OR ':'');
		  } else {
  			$where_query .= "t.thread_subject LIKE '%".$similar_words[$i]."%'".($i<$simwords_num-1 ? ' OR ':'');
		  }
	  }			
  	}
  }

  if ($where_query!="") {
  $similar_threads=0;
  if ($where_query) {
  # sql query for count
  $query_cnt = dbquery("SELECT thread_subject, thread_lastuser, thread_views, forum_name,"
  	." fu.user_id, thread_lastpost,"
  	." thread_replies, f.forum_id, t.thread_id,"
  	." fu.user_name AS last_user, thread_locked,fg.group_id"
  	." FROM ".DB_PREFIX."forums AS f"
  	." INNER JOIN ".DB_PREFIX."threads AS t USING(forum_id)"
  	." LEFT OUTER JOIN ".DB_PREFIX."users AS fu ON fu.user_id=t.thread_lastuser"
  	." LEFT OUTER JOIN ".DB_PREFIX."forum_groups fg ON fg.forum_id=f.forum_id AND fg.auth_read='1'"
    ." WHERE (".$where_query.") AND (".forum_groupaccess('f.forum_access')." OR ".forum_groupaccess('fg.group_id').") AND t.thread_id<>'".$tid."'"
    ." GROUP BY t.thread_id ORDER BY t.thread_lastpost DESC".($pagenav ? " LIMIT ".$start.",".$cnt : ''));
  $similar_threads = dbrows($query_cnt);
  # sql query for list threads
  if($cnt!=0 AND $similar_threads>$cnt) {
   $query = dbquery("SELECT thread_subject, thread_lastuser, thread_views, forum_name,"
    	." fu.user_id, thread_lastpost,"
    	." f.forum_id, t.thread_id,"
	    ." fu.user_name AS last_user, thread_locked,thread_replies,fg.group_id"
    	." FROM ".DB_PREFIX."forums AS f"
    	." INNER JOIN ".DB_PREFIX."threads AS t USING(forum_id)"
    	." LEFT JOIN ".DB_PREFIX."users AS fu ON fu.user_id=t.thread_lastuser"
    	." LEFT OUTER JOIN ".DB_PREFIX."forum_groups fg ON fg.forum_id=f.forum_id AND fg.auth_read='1'"
	    ." WHERE (".$where_query.") AND (".forum_groupaccess('f.forum_access')."  OR ".forum_groupaccess('fg.group_id').")"
		." AND t.thread_id<>'".$tid."'"
    	." GROUP BY t.thread_id"
    	.($order==FALSE ? " ORDER BY rand()"
    	." LIMIT ".$start.",".$cnt : " ORDER BY t.thread_lastpost DESC"
    	." LIMIT ".$start.",".$cnt));
  } else {
    $query = $query_cnt;
  }
	if(dbrows($query)>0) {
		opentable($locale['PDST201']." &quot;".$title."&quot;&nbsp;[".$similar_threads."]");
			echo "<table cellspacing='1' width='100%' class='tbl-border'>
					<thead>
						<tr>
						<th class='tbl2' align='left'>".$locale['PDST202']."</th>
						<th class='tbl2' align='left'>".$locale['INDEX401']."</th>
						<th class='tbl2' align='center' width='1%' style='white-space:nowrap'>".$locale['PDST203']."</th>
						<th class='tbl2' align='center' width='1%' style='white-space:nowrap'>".$locale['PDST204']."</th>
						</tr>
					</thead>
					<tbody>\n";
			$count=0;
			while($sdata = dbarray($query)) {
				$tbl = "tbl".(($count++ % 2)+1);
				echo "<tr>
					<td class='$tbl'><a href='".$tpl->url(SEO_THREAD,"viewthread.php","thread_id=",$sdata['thread_id'],null,null,$sdata['thread_subject'],'forum')."' title='".$sdata['thread_subject']."'>".trimlink($sdata['thread_subject'], 70)."</a></td>
					<td class='$tbl' align='center'><a href='".$tpl->url(SEO_FORUM,"viewforum.php","forum_id=",$sdata['forum_id'],null,null,$sdata['forum_name'],'forum')."'>".$sdata['forum_name']."</a></td>
					<td align='center' class='$tbl' style='white-space:nowrap'><b>".$sdata['thread_replies']."</b></td>
					<td class='$tbl' align='right' style='white-space:nowrap'>".showdate("forumdate", $sdata['thread_lastpost'])." ".$locale['INDEX406']."<a href='".$tpl->url(SEO_UPROFILE,"profile.php","lookup=",$sdata['thread_lastuser'],null,null,$sdata['last_user'])."'>".$sdata['last_user']."</a></td>
					</tr>\n";
			}
      if($showlink==TRUE && $similar_threads>$cnt) {
        $tbl = "tbl".(($count++ % 2)+1);
				echo "<tr>
					<td class='$tbl' align='right' valign='middle' colspan='4'><a href='".FORUM."st_list.php?tid=".$tid."'>".$locale['PDST205']." &quot;".$title."&quot;</a></td>
					</tr>\n";
		}
		echo "</tbody></table>";
		if($pagenav==TRUE && $similar_threads>$cnt) {
		  echo "<div align='center' style='margin-top:5px;'>\n".makePageNav($start,$cnt,$similar_threads,3,FORUM."st_list.php?tid=".$tid."&amp;")."\n</div>\n";
		}
		closetable();
	}
	}
	}
}
 
?>