<?php
/*=============================================================*\
|| ########################################################### ||
|| #        BS-Fusion - Content Management System            # ||
|| #                    Version 1.x                          # ||   
|| # ------------------------------------------------------- # ||
|| # Copyright 2009-2010 BS-Fusion All rights reserved.     # ||
|| # Author: Manuel Kurz                                     # ||
|| # ------------------------------------------------------- # ||
|| # This program is released as open source software under  # ||
|| # the Affero GPL license (version 3).                     # ||
|| # License: http://www.gnu.org/licenses/agpl-3.0.html.     # || 
|| # Removal of this copyright header is strictly prohibited # ||
|| # without written permission from the original author(s). # ||
|| # -------- BS-FUSION IS AN OPEN SOURCE SOFTWARE --------- # ||
|| #    http://www.bs-fusion.de | http://www.bsfusion.de     # ||
|| ########################################################### || 
\*=============================================================*/ 
if(preg_match("/maincore.php/i",$_SERVER['PHP_SELF'])) die("Access denied");

// CMS Konstante 
define("IN_FUSION",true);

// relativer Pfad in der Software
$folder_level="./";
$s=0;
while (!file_exists($folder_level."config.inc.php")) {
if($s==5) break;
$folder_level .= "../";$s++;
}

// HTTP-PORT Konstante 
define("HTTP_PORT",isset($_SERVER['SERVER_PORT']) && ((int)$_SERVER['SERVER_PORT']==443 || (int)$_SERVER['SERVER_PORT']==8443) ? 443 : 80);

// SSL_COOKIE Konstante 
define("SSL_COOKIE",HTTP_PORT==443 ? 1 : 0);

// Domain-URL Konstante
define("DOMAIN",(HTTP_PORT==443 ? 'https://':'http://').$_SERVER['SERVER_NAME']);
 
// Pfad Konstante
define("BASEDIR",$folder_level); 
define("ADMIN", BASEDIR."administration/");
define("IMAGES", BASEDIR."images/");
define("IMAGES_A", IMAGES."articles/");
define("IMAGES_AC", IMAGES."article_cats/");
define("IMAGES_DC", IMAGES."download_cats/");
define("IMAGES_N", IMAGES."news/");
define("IMAGES_NC", IMAGES."news_cats/");
define("IMAGES_R", IMAGES."ranks/");
define("INCLUDES", BASEDIR."includes/");
define("SECURITY",BASEDIR."security/");
define("LOCALE", BASEDIR."locale/");
define("FORUM", BASEDIR."forum/");
define("INFUSIONS", BASEDIR."infusions/");
define("PHOTOS", IMAGES."photoalbum/");
define("THEMES", BASEDIR."themes/");
define("JSCRIPTS",BASEDIR."jscripts/");
define("PANELS",BASEDIR."panels/");
define("DOWNLOAD_DIR",BASEDIR."downloads/");
define("SCREENS_DIR",DOWNLOAD_DIR."screens/");
define("LOG_DIR",SECURITY."logs/");


// Weitere Konstante f. verschiedene Hosteinstellungen
define("QUOTES_GPC", (bool)@ini_get('magic_quotes_gpc') ? TRUE : FALSE);
define("SAFE_MODE", (bool)@ini_get('safe_mode') ? TRUE : FALSE);
define("REGISTER_GLOBALS", (bool)@ini_get('register_globals') ? TRUE : FALSE);
if (function_exists("apache_get_modules")) {
define("MOD_REWRITE",in_array('mod_rewrite',@apache_get_modules()) ? true : false);
}
else {
	define("MOD_REWRITE",true);
}
define("iOB_GZIP",(bool)@ini_get('output_handler') && @ini_get('output_handler')=='ob_gzhandler' ? true : false);

// verschiedene User IP Adressen
define("USER_IP", $_SERVER['REMOTE_ADDR']);
define("LIP",ip2long($_SERVER['REMOTE_ADDR']));
define("FIP",((LIP >= 0) ? LIP>>24 : ((LIP &0x7fffffff)>>24)|0x80));
define("LONG_IP",LIP &0xffffff);
define("HEX_IP", dechex(LONG_IP));

// Datenbank Variable definieren
$db_name= $db_host = $db_user = $db_pass = $db_prefix='';

// Start Output Buffering
ob_start();

$db="";$settings=array();$locale = array();
// Konfurationsdatei einbinden 
if(file_exists($folder_level.'config.inc.php')){
	
include($folder_level.'config.inc.php');
// Installationsdatei suchen, wenn das System nicht installiert ist 
if (!defined("DB_PREFIX")) {if(!file_exists($folder_level."setup.php")) {die("System Error: Setup file not found!");} else {header("location:".$folder_level."setup.php");exit;}}else if (file_exists($folder_level."setup.php")) define("iSETUP",true);else{define("iSETUP",false);}

// Einbinden der MySQL Klasse
include(INCLUDES.'MySQL.php');
// Aufbau der MySQL Datenbank 
if (!$db=new MySQL($db_host,$db_user,$db_pass,$db_name)) die("System cant connect the MySQL database");
unset($db_host,$db_user,$db_pass,$db_name); // spezialzusatz, 29.12.08, ZOC
// Laden der Einstellungen

// Aufrufen der Settings
if($settings=first_query('*',DB_PREFIX."settings","site_id='1'")) {

// Pfade fr das Portal
$basefolder = $settings['absolute_path'];
$rootfolder = $settings['relative_path'];

// Einbindung des Bot-trap wenn Datei vorhanden
if (file_exists($basefolder."page.restrictor.php")) {
include($basefolder."page.restrictor.php");
}

// Ermitteln und Fixen der Basisurl
if ($settings['siteurl']!=DOMAIN.$rootfolder) {
	$settings['siteurl']=DOMAIN.$rootfolder;
}
define("BASEURL",$settings['siteurl']);

define("COOKIE_PATH",$rootfolder);

// Wartungsmodus prfen
define("iMAINTENANCE",$settings['maintenance']==0 ? false : true);

// Multilingual
define("iMULTILANG",$settings['locale_switcher']==0 ? false : true);

// Portalsprache
define("SITELOCALE",$settings['locale']);

// Portaltheme
define("SITETHEME",$settings['theme']);
############  Ende der Einstellungen ##############

// Einbindung der Allgemeinen Funktionen
include(INCLUDES."core_functions.php"); 

// Laden der Benutzerauthentification
include(INCLUDES."auth.inc.php");

// Sicherheitsprogramm einbinden
include(SECURITY.'bs_protection.inc.php');

// mod_rewrite Prfung 	
define("SEO_ON",$settings['mod_rewrite']==1?true:false);

// Seitenbanner Konstante
define("SITEBANNER",$settings['sitebanner']!="" && @file_exists(BASEDIR.$settings['sitebanner']) ? "<img src='".BASEDIR.$settings['sitebanner']."' alt='".$settings['sitename']."' title='".$settings['sitename']."'>" : $settings['sitename']);

// Wenn keine Login Erlaubnis, dann ausloggen 
if (iMEMBER && !(bool)USER_LOGIN) {redirect(BASEURL."setuser.php?logout=yes");}

locale_switcher($bs_session);
theme_switcher($bs_session);

if (LANGUAGE) {
	include_once(LOCALE.LOCALESET.'global.php');
} else {
	die(LOCALE.LOCALESET.'global.php not found!');
}
if (THEME) {
	include_once(INCLUDES."theme_functions_include.php");
    include_once(INCLUDES."class.template.php");
	if (!$tpl = new template(THEMES."templates/".$settings['template']."/")) die("Template Engine konnte nicht gestartet werden");
	$tpl->includeTemplateFile("global.tpl.php");
	include_once(THEME.'theme.php');	
} else {
	die(THEME.'theme.php not found!');
}
// Theme Einbinden
define("THEMEIMAGE", THEME."images/");
define("FORUMIMAGE", THEME."images/forum/");

if (iMAINTENANCE && !iADMIN) {
if (!preg_match("/maintenance.php/i",$_SERVER['PHP_SELF'])) redirect(BASEURL."maintenance.php");
}
if (!iMAINTENANCE && preg_match("/maintenance.php/i",$_SERVER['PHP_SELF'])) { redirect(BASEURL);
}

// rowstart Variable
$rowstart = !isset($_GET['rowstart']) ? 0 :(int)$_GET['rowstart'];
$PHP_SELF=htmlentities($_SERVER['PHP_SELF']);
$REF_LINK=$PHP_SELF.(FUSION_QUERY==''?'':'?'.FUSION_QUERY);	
##################### Ende des aktiven Portals ########################## 
} else {
die("System can`t load settings from database!");	
}
}else if(file_exists($folder_level.'setup.php')){
header('location:'.$folder_level.'setup.php');exit;}else{die($folder_level.'config.inc.php not found!');}
?>