<?php
/*---------------------------------------------------------+
| BS-Fusion - Content Management System
| Version 1.00.0
+----------------------------------------------------------+
| Copyright  2009 Manuel Kurz
| http://www.bs-fusion.org/
+----------------------------------------------------------+
| This program is released as free software under the
| Affero GPL license (version 3). You can redistribute 
| it and/or modify it under the terms of this license which 
| you can read by viewing the included agpl-3.0.txt or 
| online at http://www.gnu.org/licenses/agpl-3.0.html. 
| Removal of this copyright header is strictly prohibited 
| without written permission from the original author(s).
+----------------------------------------------------------+
| Code based on PHP-Fusion
| http://www.php-fusion.co.uk/
+----------------------------------------------------------*/
if (!include_once("maincore.php")) die("System Error: mainfile not found!");
define("SAFEMODE", @ini_get("safe_mode") ? true : false);
if (isset($photo_id) && !isNum($photo_id)) redirect(BASEDIR.FUSION_SELF);
if (isset($album_id) && !isNum($album_id)) redirect(BASEDIR.FUSION_SELF);
if (!isset($rowstart) || !isNum($rowstart)) $rowstart = 0;
$tpl->add_to_title($locale['photo400']);
if (!include_once("subheader.php")) die("System Error: subheader not found!");	
include_once("side_left.php");	
$exif_on = true; // true = show exif data if available / false = dont show exif data

if(isset($photo_id)){
	$result = dbquery(
		"SELECT tp.*, ta.*, tu.user_id,user_name, SUM(tr.rating_vote) AS sum_rating, COUNT(tr.rating_item_id) AS count_votes
		FROM ".$db_prefix."photos tp
		LEFT JOIN ".$db_prefix."photo_albums ta USING (album_id)
		LEFT JOIN ".$db_prefix."users tu ON tp.photo_user=tu.user_id
		LEFT JOIN ".$db_prefix."ratings tr ON tr.rating_item_id = tp.photo_id AND tr.rating_type='P'
		WHERE photo_id='$photo_id' GROUP BY tp.photo_id"
	);
	$data = dbarray($result);
	if (!checkgroup($data['album_access'])) {
		fallback(FUSION_SELF);
	} else {
		define("PHOTODIR", PHOTOS.(!SAFEMODE ? "album_".$data['album_id']."/" : ""));
		include INCLUDES."comments_include.php";
		include INCLUDES."ratings_include.php";
		$result=dbquery("UPDATE ".$db_prefix."photos SET photo_views=(photo_views+1) WHERE photo_id='".$photo_id."'");

		$pres = dbquery("SELECT photo_id FROM ".$db_prefix."photos WHERE photo_order='".($data['photo_order']-1)."' AND album_id='".$data['album_id']."'");
		$nres = dbquery("SELECT photo_id FROM ".$db_prefix."photos WHERE photo_order='".($data['photo_order']+1)."' AND album_id='".$data['album_id']."'");
		if (dbrows($pres)) $prev = dbarray($pres);
		if (dbrows($nres)) $next = dbarray($nres);

		opentable($locale['photo450']);
		if ($data['photo_thumb2']) { $photo_thumb = PHOTODIR.$data['photo_thumb2']; } else { $photo_thumb = ""; }
		$photo_file = PHOTODIR.$data['photo_filename'];
		$photo_size = @getimagesize($photo_file);

		echo "<table cellpadding='0' cellspacing='0' width='100%'>\n<tr>\n<td class='tbl2'>\n";
		echo "<a href='".FUSION_SELF."'>".$locale['photo400']."</a> &gt;\n";
		echo "<a href='".FUSION_SELF."?album_id=".$data['album_id']."'>".$data['album_title']."</a> &gt;\n";
		echo "<a href='".FUSION_SELF."?photo_id=$photo_id'>".$data['photo_title']."</a>\n</td>\n";		
		if ((isset($prev['photo_id']) && isNum($prev['photo_id'])) || (isset($next['photo_id']) && isNum($next['photo_id']))) {
			if (isset($prev)) echo "<td width='1%' class='tbl2'><a href='".FUSION_SELF."?photo_id=".$prev['photo_id']."' title='".$locale['photo451']."'>&lt;&lt;</a></td>\n";
			if (isset($next)) echo "<td width='1%' class='tbl2'><a href='".FUSION_SELF."?photo_id=".$next['photo_id']."' title='".$locale['photo452']."'>&gt;&gt;</a></td>\n";
		}
		echo "</tr>\n</table>\n";
		tablebreak();
		// photo
		echo "<div align='center' style='margin:5px;'><a id='thumb1' href='".$photo_file."' class='highslide' onclick='return hs.expand(this)'><img src='".($photo_thumb ? $photo_thumb : $photo_file)."' title='Click to enlarge' alt='".$data['photo_filename']."' style='border:1pt dotted #C0C0C0;' ></a></div>\n";
		echo "<div align='center' style='margin:5px 0px 5px 0px'>\n";
		if ($data['photo_description']) echo "<b>".nl2br(parseubb($data['photo_description']))."</b><br><br>\n";
		echo $locale['photo433'].showdate("shortdate", $data['photo_datestamp'])."<br>\n";
		echo $locale['photo434']."<a href='".BASEDIR."profile.php?lookup=".$data['user_id']."'>".$data['user_name']."</a><br>\n";
		echo $locale['photo454']."$photo_size[0] x $photo_size[1] ".$locale['photo455']."<br>\n";
		echo $locale['photo456'].parsebytesize(filesize($photo_file))."<br>\n";
		echo $locale['photo436'].dbcount("(comment_id)", "comments", "comment_type='P' AND comment_item_id='".$data['photo_id']."'")."<br>\n";
		echo $locale['photo437'].($data['count_votes'] > 0 ? str_repeat("<img src='".IMAGES."star.gif' alt='*' style='vertical-align:middle'>", ceil($data['sum_rating'] / $data['count_votes'])) : $locale['photo438'])."<br>\n";
		echo $locale['photo457'].$data['photo_views']."</div>\n";
		closetable();
		if ($data['photo_allow_comments'] == "1") showcomments("P","photos","photo_id",$photo_id,FUSION_SELF."?photo_id=$photo_id");
		if ($data['photo_allow_ratings']) showratings("P",$photo_id,FUSION_SELF."?photo_id=$photo_id");

		// EXIF
		// check if jpg and exif
		if($photo_size[2]=='2' && function_exists('exif_read_data')) {
		$exif = exif_read_data(PHOTODIR.$data['photo_filename'], 0, true);
		$datetime = $exif['EXIF']['DateTimeOriginal'];
		// check if data
		if(isset($datetime)) {
			opentablex("<center><strong>EXIF</strong></center>",off);
			@include_once INCLUDES."exif.inc.php";
			closetablex();
			}
		}		
		
	}
} elseif (isset($album_id)) {
	define("PHOTODIR", PHOTOS.(!SAFEMODE ? "album_".$album_id."/" : ""));
	$result = dbquery(
		"SELECT ta.* FROM ".$db_prefix."photo_albums ta WHERE album_id='$album_id'"
	);
	if (!dbrows($result)) {
		fallback(FUSION_SELF);
	} else {
		$data = dbarray($result);
		if (!checkgroup($data['album_access'])) {
			fallback(FUSION_SELF);
		} else {
			$rows = dbcount("(photo_id)", "photos", "album_id='$album_id'");
			opentable($locale['photo420']);
			tablebreak();
			echo "<table align='left' cellpadding='0' cellspacing='0' width='100%'>\n<tr>\n";
			echo "<td rowspan='2' align='center' class='tbl1'><img src='".PHOTOS.$data['album_thumb']."'></td>\n";
			echo "<td valign='top' width='100%'><div class='tbl2' style='font-weight:bold;vertical-align:top'>".$locale['photo421'].$data['album_title']."</div>\n";
			echo "<div class='tbl1' style='vertical-align:middle'>".nl2br(parseubb($data['album_description']))."</div>\n</td>\n</tr>\n";
			echo "<tr>\n<td valign='bottom' width='100%'>\n<div class='tbl2' style='vertical-align:bottom'>\n";
			if ($rows) {
				$pdata = dbarray(dbquery("SELECT tp.*, tu.user_id,user_name FROM ".$db_prefix."photos tp LEFT JOIN ".$db_prefix."users tu ON tp.photo_user=tu.user_id WHERE album_id='$album_id' ORDER BY photo_datestamp DESC LIMIT 1"));
				echo $locale['photo422']."$rows<br>\n";
				echo $locale['photo423']."<a href='".BASEDIR."profile.php?lookup=".$pdata['user_id']."'>".$pdata['user_name']."</a>".$locale['041'].showdate("longdate", $pdata['photo_datestamp'])."\n";
			} else {
				echo $locale['photo425']."\n";
			}
			echo "</div>\n</td>\n</tr>\n</table>";
			tablebreak();
			closetable();
			if ($rows) {
				tablebreak();
				opentable($locale['photo430']);
				$result = dbquery(
					"SELECT tp.*, tu.user_id,user_name, SUM(tr.rating_vote) AS sum_rating, COUNT(tr.rating_item_id) AS count_votes
					FROM ".$db_prefix."photos tp
					LEFT JOIN ".$db_prefix."users tu ON tp.photo_user=tu.user_id
					LEFT JOIN ".$db_prefix."ratings tr ON tr.rating_item_id = tp.photo_id AND tr.rating_type='P'
					WHERE album_id=$album_id GROUP BY photo_id ORDER BY photo_order LIMIT $rowstart,".$settings['thumbs_per_page']
				);
				$counter = 0;
				echo "<table cellpadding='0' cellspacing='1' width='100%'>\n<tr>\n<td class='tbl2'>\n";
				echo "<a href='".FUSION_SELF."'>".$locale['photo400']."</a> &gt;\n";
				echo "<a href='".FUSION_SELF."?album_id=".$data['album_id']."'>".$data['album_title']."</a>\n";
				echo "</td>\n</tr>\n</table>\n";
				tablebreak();
				echo "<table cellpadding='0' cellspacing='1' width='100%'>\n<tr>\n";
				while ($data = dbarray($result)) {
					if ($counter != 0 && ($counter % $settings['thumbs_per_row'] == 0)) echo "</tr>\n<tr>\n";
					echo "<td align='center' valign='top' class='tbl'>\n";
					echo "<b>".$data['photo_title']."</b><br><br>\n<a href='".FUSION_SELF."?photo_id=".$data['photo_id']."'>";
					if ($data['photo_thumb1'] && file_exists(PHOTODIR.$data['photo_thumb1'])){
						echo "<img src='".PHOTODIR.$data['photo_thumb1']."' alt='".$data['photo_thumb1']."' title='".$locale['photo431']."' border='0'>";
					} else {
						echo $locale['photo432'];
					}
					echo "</a><br><br>\n<span class='small'>\n";
					echo $locale['photo433'].showdate("shortdate", $data['photo_datestamp'])."<br>\n";
					echo $locale['photo434']."<a href='".BASEDIR."profile.php?lookup=".$data['user_id']."'>".$data['user_name']."</a><br>\n";
					echo $locale['photo436'].dbcount("(comment_id)", "comments", "comment_type='P' AND comment_item_id='".$data['photo_id']."'")."<br>\n";
					echo $locale['photo437'].($data['count_votes'] > 0 ? str_repeat("<img src='".IMAGES."star.gif' alt='*' style='vertical-align:middle'>", ceil($data['sum_rating'] / $data['count_votes'])) : $locale['photo438'])."<br>\n";
					echo $locale['photo435'].$data['photo_views']."</span><br>\n";
					echo "</td>\n";
					$counter++;
				}
				echo "</tr>\n</table>\n";
				closetable();
			}
			if ($rows > $settings['thumbs_per_page']) echo "<div align='center' style='margin-top:5px;'>\n".makePageNav($rowstart,$settings['thumbs_per_page'],$rows,3,FUSION_SELF."?album_id=$album_id&amp;")."\n</div>\n";
		}
	}
} else {
	opentable($locale['photo400']);
	$rows = dbcount("(album_id)", "photo_albums", groupaccess('album_access'));
	if ($rows) {
		$result = dbquery(
			"SELECT ta.*, tu.user_id,user_name FROM ".$db_prefix."photo_albums ta
			LEFT JOIN ".$db_prefix."users tu ON ta.album_user=tu.user_id
			WHERE ".groupaccess('album_access')." ORDER BY album_order
			LIMIT $rowstart,".$settings['thumbs_per_page']
		);
		$counter = 0; $r = 0; $k = 1;
		echo "<table cellpadding='0' cellspacing='1' width='100%'>\n<tr>\n";
		while ($data = dbarray($result)) {
			if ($counter != 0 && ($counter % $settings['thumbs_per_row'] == 0)) echo "</tr>\n<tr>\n";
			echo "<td align='center' valign='top' class='tbl'>\n";
			echo "<b>".$data['album_title']."</b><br><br>\n<a href='".FUSION_SELF."?album_id=".$data['album_id']."'>";
			if ($data['album_thumb'] && file_exists(PHOTOS.$data['album_thumb'])){
				echo "<img src='".PHOTOS.$data['album_thumb']."' alt='".$data['album_thumb']."' title='".$locale['photo401']."' border='0'>";
			} else {
				echo $locale['photo402'];
			}
			echo "</a><br><br>\n<span class='small'>\n";
			echo $locale['photo403'].showdate("shortdate", $data['album_datestamp'])."<br>\n";
			echo $locale['photo404']."<a href='".BASEDIR."profile.php?lookup=".$data['user_id']."'>".$data['user_name']."</a><br>\n";
			echo $locale['photo405'].dbcount("(photo_id)", "photos", "album_id='".$data['album_id']."'")."</span><br>\n";
			echo "</td>\n";
			$counter++; $k++;
		}
		echo "</tr>\n</table>\n";
		closetable();
		if ($rows > $settings['thumbs_per_page']) echo "<div align='center' style='margin-top:5px;'>\n".makePageNav($rowstart,$settings['thumbs_per_page'],$rows,3)."\n</div>\n";
	}else{
		echo "<center><br>".$locale['photo406']."<br><br></center>\n";
		closetable();
	}
}

require "side_right.php";
require "footer.php";
?>